
#include <Eigen/Dense>
using namespace Eigen;

#ifndef _EVALUATIONCONFIGURERATIONS_H_
#define _EVALUATIONCONFIGURERATIONS_H_


extern double h_BS;
extern double inter_site_distance;
extern double secter_to_ue_min_distance;
extern double indoor_ue_speed;
extern double outdoor_ue_pedestrian_speed;
extern double outdoor_ue_car_speed;
extern double micro_min_inter_site_distance;
extern double micro_cell_radius;

extern double ue_antenna_element_gain;
extern double bs_antenna_element_gain;

extern double ANGLE_3dB_h;
extern double ANGLE_3dB_v;

extern double bs_noise_figure;
extern double ue_noise_figure;
extern double thermal_nosie_level;
extern double simulation_bandwidth;

extern double high_loss_type_portion;
extern double indoor_ue_portion;
extern double outdoor_pedestrian_portion;
extern int num_floor;
extern int num_propagation_condition;


extern double L_glass;
extern double L_IRRglass;
extern double L_concrete;
extern double L_wood;

extern double Low_loss_model;
extern double High_loss_model;
extern double Low_loss_model_std;
extern double High_loss_model_std;

extern double car_penet_loss_mean;
extern double car_penet_loss_std;

extern double h;
extern double W;


#endif