#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include "const.h"
#include <vector> 
#include <algorithm> 
#include "paramStatistics.h"

using namespace std;


void Collect_Couplingloss()
{
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		_couplingloss[drop_idx*num_ue+ue_idx] = ue[ue_idx].LS_gain[ue[ue_idx].sector_in_control];
	}
}


void Get_Couplingloss_CDF()
{
	
	vector <double> _couplingloss_cdf;

	_couplingloss_cdf.clear();
	

	sort(_couplingloss, _couplingloss + num_ue*num_drops);
	
	_couplingloss_cdf.push_back(_couplingloss[0]);
	

	
	for (int percentile = 1; percentile < 101; percentile++)
	{
		int idx = (int)
			
			((num_ue*num_drops - 1)*percentile*0.01);
		_couplingloss_cdf.push_back(_couplingloss[idx]);
	}
	


	ofstream  Couplingloss;
	char file_name[50];

	strcpy_s(file_name, sizeof(file_name), "Couplingloss");
	
	if (pathloss_model == InH_A)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Pathloss_A.xls");
		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Pathloss_A.xls");
		}
		else 
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Pathloss_A.xls");
		}

	}
	else if (pathloss_model == InH_B)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Pathloss_B.xls");
		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Pathloss_B.xls");
		}
		else
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Pathloss_B.xls");
		}
	}
	else if (pathloss_model == UMa_A || pathloss_model == UMi_A)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Pathloss_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Pathloss_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Pathloss_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Pathloss_A.xls");
		}
	}
	else if (pathloss_model == UMa_B || pathloss_model== UMi_B)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Pathloss_B.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Pathloss_B.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Pathloss_B.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Pathloss_B.xls");
		}
	}
	else if (pathloss_model == RMa_A)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Pathloss_A.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Pathloss_A.xls");
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Pathloss_A.xls");
		}
	}
	else if (pathloss_model == RMa_B)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Pathloss_B.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Pathloss_B.xls");
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Pathloss_B.xls");
		}
	}

	Couplingloss.open(file_name, ios::out);
	Couplingloss <<"# CDF" << "\t" << "# Couplingloss "  << endl;

	for (int x_idx = 0; x_idx < 101; x_idx++)
	{
		Couplingloss << _couplingloss_cdf[x_idx] << "\t" << x_idx  << endl;
	}


	Couplingloss.close();

}