#include <iostream>
#include <Eigen/Dense>
#include "paramSimul.h"
#include "paramFastFading.h"
#include "const.h"
using namespace Eigen;
using namespace std;

void Set_antenna_location_matrix()
{
	W_rx = MatrixXd(P_bs*Mg_bs*Ng_bs*M_bs*N_bs,3);
	W_tx = MatrixXd(P_ue*Mg_ue*Ng_ue*M_ue*N_ue,3);

	
	
	dg_H_bs = dg_H_bs * lamda_0;
	dg_V_bs = dg_V_bs * lamda_0;
	dg_H_ue = dg_H_ue * lamda_0;
	dg_V_ue = dg_V_ue * lamda_0;

	d_H_bs = d_H_bs * lamda_0;
	d_V_bs = d_V_bs * lamda_0;
	d_H_ue = d_H_ue * lamda_0;
	d_V_ue = d_V_ue * lamda_0;
	


	for (int i= 0; i< P_bs*Mg_bs*Ng_bs*M_bs*N_bs;i++)
	{
		W_rx(i, 0) = 0;
		W_rx(i, 1) = floor((i - P_bs *N_bs*floor(i / (P_bs*N_bs))) / P_bs)*d_H_bs + floor((i - P_bs * N_bs*Ng_bs*floor(i / (P_bs * N_bs * Ng_bs))) / (P_bs*N_bs)) *dg_H_bs;
		W_rx(i, 2) = floor((i - P_bs *N_bs*M_bs*Ng_bs*floor(i / (P_bs*N_bs*M_bs*Ng_bs))) / (P_bs*N_bs*Ng_bs))*d_V_bs + floor((i - P_bs *N_bs*M_bs*Ng_bs*Mg_bs*floor(i / (P_bs*N_bs*M_bs*Ng_bs*Mg_bs))) / (P_bs*N_bs*M_bs*Ng_bs))*dg_V_bs;
		
	}

	for (int i = 0; i< P_ue*Mg_ue*Ng_ue*M_ue*N_ue; i++)
	{
		W_tx(i, 0) = 0;
		W_tx(i, 1) = floor((i - P_ue *N_ue*floor(i / (P_ue*N_ue))) / P_ue)*d_H_ue + floor((i - P_ue * N_ue*Ng_ue*floor(i / (P_ue * N_ue * Ng_ue))) / (P_ue*N_ue)) *dg_H_ue;
		W_tx(i, 2) = floor((i - P_ue *N_ue*M_ue*Ng_ue*floor(i / (P_ue*N_ue*M_ue*Ng_ue))) / (P_ue*N_ue*Ng_ue))*d_V_ue + floor((i - P_ue *N_ue*M_ue*Ng_ue*Mg_ue*floor(i / (P_ue*N_ue*M_ue*Ng_ue*Mg_ue))) / (P_ue*N_ue*M_ue*Ng_ue))*dg_V_ue;
	}

}